<template>
  <v-dialog
    v-model="show"
    width="30%"
  >
    <v-card>
      <v-card-title class="title">
        Import data
      </v-card-title>
      <v-card-text>
        <p>
          You can use this component to import data into Grady.
          You can use
          <a
            href="https://gitlab.gwdg.de/grady-corp/rusty-hektor"
            target="_blank"
          >rusty-hektor</a> to convert
          and pseudonomize ILIAS output.
        </p>
        <v-file-input
          id="file-input"
          v-model="hektorFile"
          label="Select file"
          accept="application/JSON"
        />
      </v-card-text>
      <v-card-actions>
        <v-btn
          id="submit-import"
          :loading="loading"
          :disabled="!hektorFile"
          @click="submitData"
        >
          Import
        </v-btn>
        <v-btn
          color="red"
          @click="$emit('hide')"
        >
          Cancel
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<script>
  import { importData } from '@/api'

  export default {
    name: 'ImportDialog',
    data: () => {
      return {
        show: true,
        loading: false,
        hektorFile: null
      }
    },
    watch: {
      show(val) {
        if (!val) {
          this.$emit('hide')
        }
      }
    },
    methods: {
      async submitData() {
        this.loading = true
        let data
        try {
          data = await this.readFile()
          data = JSON.parse(data)
        } catch (error) {
          this.$notify({
            type: 'error',
            title: 'Error reading import file',
            text: error.message
          })
          this.loading = false
          return
        }

        try {
          await importData(data)
          this.$emit('imported')
          this.$notify({
              title: 'Successfully imported data. Please log out and in again.',
              type: 'success'
          })
        } finally {
          this.loading = false
          this.show = false
        }
      },
      readFile() {
        const fileReader = new FileReader()
        return new Promise((resolve, reject) => {
          fileReader.onload = event => {
            resolve(event.target.result)
          }
          fileReader.onerror = () => {
            fileReader.abort()
            reject(new Error('Problem parsing input file.'))
          }
          fileReader.readAsText(this.hektorFile)
        })
      }
    }
  }
</script>
